# links

A collection of articles & links

## Self-Hosted
- [AFFiNE](https://github.com/toeverything/AFFiNE) - A Notion alternative

## Reading

- [The Challenges of Formally Proving HPC Systems Software](https://www.osti.gov/biblio/1500167)
- [SSReflect Tutorial](https://jfr.unibo.it/article/view/1979/1358)
    - [Exercise Examples](https://github.com/catalin-hritcu/exos-ssr/tree/master/Catalin)
- [Orchestrating Layered Attestations](https://ku-sldg.github.io/copland/resources/copland-post-2019.pdf)
- [Design & Formal Verification of a Copland-based Attestation Protocol](https://ampetz.github.io/resources/memocode21_camera-ready.pdf)
- [SymForce: Symbolic Computation and Code Generation for Robotics](https://arxiv.org/abs/2204.07889)
- [Formal reasoning about layered monadic interpreters](https://dl.acm.org/doi/10.1145/3547630)
- [And now it's all this](https://leancrew.com/all-this/2021/07/back-to-netnewswire/)
    - [simpler syndication](https://leancrew.com/all-this/2015/11/simpler-syndication/)
    - [lawyers guns and money blog](https://www.lawyersgunsmoneyblog.com/)
- [Files are hard](https://danluu.com/file-consistency/)
- Foundational
    - [Certified Programming with Dependent Types](http://adam.chlipala.net/cpdt/cpdt.pdf)
    - [Types and Programming Languages](https://basics.sjtu.edu.cn/~xiaojuan/tapl2016/files/Types+and+Programming+Languages.pdf)

### Type-Theory
- [An Introduction to Type Theory and Formal Semantics](https://staffwww.fullcoll.edu/aclifton/files/intro-to-type-theory.pdf)
- [A Dependent Type Theory with Abstractable Names](https://www.cl.cam.ac.uk/~amp12/papers/deptta/deptta-preprint.pdf)
- [Certified Programming with Dependent Types](http://adam.chlipala.net/cpdt/cpdt.pdf)


### Development

- [CatchTS](https://catchts.com/) - A TypeScript blog
- [Extreme Explorations of TypeScript's Type System](https://www.learningtypescript.com/articles/extreme-explorations-of-typescripts-type-system)
- [Adrian Holovaty](https://www.holovaty.com/writing/)

## System Administration

- [endoflife.date](https://endoflife.date/) - community-maintained verison lifecycle info

### Proxmox

- [How to import .ova file into Proxmox](https://ryanburnette.com/blog/proxmox-import-ova/)

### Kubernetes

- [OAuth2 proxy for NGINX ingress controller](https://kubernetes.github.io/ingress-nginx/examples/auth/oauth-external-auth/)
- [Production Ready EKS CoreDNS Configuration](https://medium.com/cloutive/production-ready-eks-coredns-configuration-6fea830606f8)

## Development

### Languages

- [v-lang](https://github.com/vlang/v)
- [Bun JavaScript runtime](https://bun.sh/)
- [JetBrains Arend Prover](https://arend-lang.github.io/)

### Rendering

- [morphdom](https://github.com/patrick-steele-idem/morphdom) - A tool for diffing & applying DOM changes
- [How to use JSX without React](https://betterprogramming.pub/how-to-use-jsx-without-react-21d23346e5dc)
    - [React JSX types](https://github.com/DefinitelyTyped/DefinitelyTyped/blob/218978baf658fe6be611983776ca9f9705e2f598/types/react/index.d.ts)
    - [DOM Element factory for TypeScript](https://www.meziantou.net/write-your-own-dom-element-factory-for-typescript.htm)

### TypeScript

- [ts-node](https://github.com/TypeStrong/ts-node) - A TypeScript REPL/runner
- [Type Fest](https://github.com/sindresorhus/type-fest) - A collection of utility types
- [typetype](https://github.com/mistlog/typetype) - a language for generating TypeScript types
- [json-decoder](https://github.com/venil7/json-decoder) - a TypeScript-native JSON library
- [typescript-is](https://github.com/woutervh-/typescript-is) - runtime type valiation

### Database

- [prql](https://github.com/prql/prql) - An alternative query language that compiles to SQL
- [PlanetScale](https://planetscale.com/) - H-scaling MySQL platform, also Beam team workspace
- [SurrealDB](https://surrealdb.com/) - Database platform w/ built-in real-time, authentication, and more

### LTI 1.3

- [Dynamic Registration Guide](https://moodlelti.theedtech.dev/dynreg/)
- [Blackboard Implementation Guide](https://docs.blackboard.com/lti/tutorials/implementation-guide)
- [Packback PHP Library](https://github.com/packbackbooks/lti-1-3-php-library)


### Tools

- [git-less](https://gitless.com/) - Alternative git porcelain
- [gitpod](https://github.com/gitpod-io/gitpod) - Ephemeral, Kubernetes development environments
- [JetBrains Space On-Premisis](https://www.jetbrains.com/help/space/production-installation.html)
- [JetBrains Fleet](https://www.jetbrains.com/fleet)
- [dsq](https://github.com/multiprocessio/dsq) - SQL queries across many data formats

### Bugs
- [CEF Tooltip Blanks Screen](https://bitbucket.org/chromiumembedded/cef/issues/3347/in-fullscreen-on-mac-an-html-title)
- [Can't import PKCS#12 CA certs w/ NetworkManager](https://gitlab.gnome.org/GNOME/NetworkManager-openvpn/-/issues/83)

## Off-Topic

- [The CRAPL - an academic-strength open-source license](https://matt.might.net/articles/crapl/)
- [GPR](https://integrated.ugcs.com/gpr) - Drone-powered geographical surveys
- [DoE NEPA](https://www.energy.gov/nepa/nepa-documents) - Documents required by DoE for environmental impact survey
- [If-Im-Gone](https://news.ycombinator.com/item?id=31943941) - Template cheat-sheet for your partner
- [neeasade/dotfiles](https://github.com/neeasade/dotfiles)
- [Big data datasets](https://github.com/niderhoff/big-data-datasets)
    - [PVS](https://www.kaggle.com/datasets/jefmenegazzo/pvs-passive-vehicular-sensors-datasets) - large, mostly text dataset


### Places

- [Strait of Malacca](https://www.google.com/search?q=phang%2Bnga%2Bbay%2Bstrait%2Bof%2Bmalacca&hl=en&source=lnms&tbm=isch&sa=X&ved=2ahUKEwjOjM7Mgtj4AhUTA94KHbEEDasQ_AUoAXoECAEQAw&biw=1904&bih=916&dpr=1)
